﻿Public Class DrawableCircle
    Implements IDrawable

    ' Non-IDrawable properties.
    Public Property Radius As Integer

    ' From the IDrawable interface.
    Public Property X As Integer Implements IDrawable.X
    Public Property Y As Integer Implements IDrawable.Y
    Public Property Background As System.Drawing.Brush Implements IDrawable.Background
    Public Property Foreground As System.Drawing.Pen Implements IDrawable.Foreground

    ' Draw the circle centered at (X, Y).
    Public Sub Draw(ByVal gr As System.Drawing.Graphics) Implements IDrawable.Draw
        gr.FillEllipse(Background, X - Radius, Y - Radius,
            2 * Radius, 2 * Radius)
        gr.DrawEllipse(Foreground, X - Radius, Y - Radius,
            2 * Radius, 2 * Radius)
    End Sub

    ' Constructor.
    Public Sub New(ByVal newX As Integer, ByVal newY As Integer, ByVal newBackground As Brush, ByVal newForeground As Pen, ByVal newRadius As Integer)
        X = newX
        Y = newY
        Background = newBackground
        Foreground = newForeground
        Radius = newRadius
    End Sub
End Class
