﻿Public Class DrawableStar
    Implements IDrawable

    ' Non-IDrawable properties.
    Public Property Width As Integer
    Public Property Height As Integer
    Public Property NumberOfPoints As Integer

    ' From the IDrawable interface.
    Public Property X As Integer Implements IDrawable.X
    Public Property Y As Integer Implements IDrawable.Y
    Public Property Background As System.Drawing.Brush Implements IDrawable.Background
    Public Property Foreground As System.Drawing.Pen Implements IDrawable.Foreground

    ' Draw the star centered at (X, Y).
    Public Sub Draw(ByVal gr As System.Drawing.Graphics) Implements IDrawable.Draw
        ' Calculate the points.
        Dim points(0 To NumberOfPoints - 1) As Point
        Dim wid As Double = Width / 2
        Dim hgt = Height / 2
        Dim cx As Integer = CInt(X + wid)
        Dim cy As Integer = CInt(Y + Height)
        Dim theta As Double = -Math.PI / 2
        Dim dtheta As Double = Math.PI * 2 / NumberOfPoints * (NumberOfPoints \ 2)
        For i As Integer = 0 To NumberOfPoints - 1
            points(i).X = CInt(Math.Round(cx + wid * Math.Cos(theta)))
            points(i).Y = CInt(Math.Round(cy + hgt * Math.Sin(theta)))
            theta += dtheta
        Next i

        gr.FillPolygon(Background, points)
        gr.DrawPolygon(Foreground, points)
    End Sub

    ' Constructor.
    Public Sub New(ByVal newX As Integer, ByVal newY As Integer, ByVal newBackground As Brush, ByVal newForeground As Pen, ByVal newWidth As Integer, ByVal newHeight As Integer, ByVal newNumberOfPoints As Integer)
        X = newX
        Y = newY
        Background = newBackground
        Foreground = newForeground
        Width = newWidth
        Height = newHeight
        NumberOfPoints = newNumberOfPoints
    End Sub
End Class
