﻿Public Class ListViewItemComparer
    Implements IComparer

    ' The column we need to sort on.
    Public Property ColumnNumber As Integer

    ' Initializing constructor.
    Public Sub New(ByVal newColumnNumber As Integer)
        ColumnNumber = newColumnNumber
    End Sub

    ' Compare.
    Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare
        ' Convert the objects into ListViewItems.
        Dim item1 As ListViewItem = DirectCast(x, ListViewItem)
        Dim item2 As ListViewItem = DirectCast(y, ListViewItem)

        ' Get the items' text.
        Dim text1 As String = item1.SubItems(ColumnNumber).Text
        Dim text2 As String = item2.SubItems(ColumnNumber).Text

        ' See how the column is aligned.
        If (item1.ListView.Columns(ColumnNumber).TextAlign = HorizontalAlignment.Left) Then
            ' Left aligned. Treat as a string.
            Return text1.CompareTo(text2)
        Else
            ' Right aligned. Treat as a number.
            Dim value1 As Double = Double.Parse(text1, System.Globalization.NumberStyles.Any)
            Dim value2 As Double = Double.Parse(text2, System.Globalization.NumberStyles.Any)
            Return -value1.CompareTo(value2)
        End If
    End Function
End Class
